<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/convert_date_to_binary_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv2_p0 { color: #e0ffff; }
.textRainbow_lv1_o0 { color: #ffffe0; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/19/85  convert_date_to_binary_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The convert_date_to_binary_ subroutine converts a character
<span id="L4" class="LineNr">  4 </span>representation of a date and time into a 72-bit clock reading.  It
<span id="L5" class="LineNr">  5 </span>accepts a wide variety of date and time forms, including the output of
<span id="L6" class="LineNr">  6 </span>the date_time_ subroutine.
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>Entry points in convert_date_to_binary_:
<span id="L10" class="LineNr"> 10 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>:Entry: convert_date_to_binary_: 02/19/85  convert_date_to_binary_
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Function:
<span id="L17" class="LineNr"> 17 </span>converts a character representation of a date and time into a 72-bit
<span id="L18" class="LineNr"> 18 </span>clock reading.
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>Syntax:
<span id="L22" class="LineNr"> 22 </span>declare convert_date_to_binary_ entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed
<span id="L23" class="LineNr"> 23 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L24" class="LineNr"> 24 </span>call convert_date_to_binary_ <span class="textRainbow_lv0_p0">(</span>time_string<span class="textRainbow_lv0_o0">,</span> clock<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L25" class="LineNr"> 25 </span>
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>Arguments:
<span id="L28" class="LineNr"> 28 </span>time_string
<span id="L29" class="LineNr"> 29 </span>   the string to be converted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> See Time String below for a
<span id="L30" class="LineNr"> 30 </span>   description of valid string values.
<span id="L31" class="LineNr"> 31 </span>
<span id="L32" class="LineNr"> 32 </span>clock
<span id="L33" class="LineNr"> 33 </span>   the resulting clock value.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> Unchanged if an error occurs.
<span id="L34" class="LineNr"> 34 </span>code
<span id="L35" class="LineNr"> 35 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can have one of the
<span id="L36" class="LineNr"> 36 </span>   following values:
<span id="L37" class="LineNr"> 37 </span>   error_table_$bad_conversion
<span id="L38" class="LineNr"> 38 </span>      a conversion condition occurred while trying to convert a value.
<span id="L39" class="LineNr"> 39 </span>   error_table_$dt_ambiguous_time
<span id="L40" class="LineNr"> 40 </span>      there is no language common to all words in the time string.
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>   error_table_$dt_bad_fw
<span id="L44" class="LineNr"> 44 </span>      fiscal_week &lt; 1 or fiscal_week &gt; year_max <span class="textRainbow_lv0_p0">(</span>which is 52 or 53<span class="textRainbow_lv0_p0">)</span>.
<span id="L45" class="LineNr"> 45 </span>   error_table_$dt_hour_gt_twelve
<span id="L46" class="LineNr"> 46 </span>      the hour given exceeds 12.
<span id="L47" class="LineNr"> 47 </span>   error_table_$dt_multiple_date_spec
<span id="L48" class="LineNr"> 48 </span>      more than one instance of a date has been given.
<span id="L49" class="LineNr"> 49 </span>   error_table_$dt_multiple_diw_spec
<span id="L50" class="LineNr"> 50 </span>      day of the week specified more than once.
<span id="L51" class="LineNr"> 51 </span>   error_table_$dt_multiple_meaning
<span id="L52" class="LineNr"> 52 </span>      the time string does not have the same meaning in all potential
<span id="L53" class="LineNr"> 53 </span>      languages, these being the intersection of all the languages
<span id="L54" class="LineNr"> 54 </span>      possible for all words present.
<span id="L55" class="LineNr"> 55 </span>   error_table_$dt_multiple_time_spec
<span id="L56" class="LineNr"> 56 </span>      more than one instance of a time has been given.
<span id="L57" class="LineNr"> 57 </span>   error_table_$dt_multiple_zone_spec
<span id="L58" class="LineNr"> 58 </span>      the zone may only be specified once.
<span id="L59" class="LineNr"> 59 </span>
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>   error_table_$dt_time_conversion_error
<span id="L62" class="LineNr"> 62 </span>      For any of the following reasons:
<span id="L63" class="LineNr"> 63 </span>      a.  General syntax error
<span id="L64" class="LineNr"> 64 </span>      b.  Month without a day number.
<span id="L65" class="LineNr"> 65 </span>      c.  Midnight or noon preceded by an hour other than 12.
<span id="L66" class="LineNr"> 66 </span>      d.  Improper use of comma or period.
<span id="L67" class="LineNr"> 67 </span>      e.  Improper use of offset.
<span id="L68" class="LineNr"> 68 </span>   error_table_$dt_size_error
<span id="L69" class="LineNr"> 69 </span>      the size condition occurred while converting the time string.
<span id="L70" class="LineNr"> 70 </span>   error_table_$too_many_tokens
<span id="L71" class="LineNr"> 71 </span>      the time string contains more tokens than the routine is prepared
<span id="L72" class="LineNr"> 72 </span>      to handle.
<span id="L73" class="LineNr"> 73 </span>   error_table_$dt_unknown_word
<span id="L74" class="LineNr"> 74 </span>      a word in a time string is not found in the time_info_ token
<span id="L75" class="LineNr"> 75 </span>      list.
<span id="L76" class="LineNr"> 76 </span>
<span id="L77" class="LineNr"> 77 </span>
<span id="L78" class="LineNr"> 78 </span>Time string:
<span id="L79" class="LineNr"> 79 </span>The time string can have up to six parts -- adverbial offset, date,
<span id="L80" class="LineNr"> 80 </span>time, day of week, signed offset, and time zone.  Adverbial offsets, if
<span id="L81" class="LineNr"> 81 </span>present, must appear leftmost in the string.  Beyond that, all of the
<span id="L82" class="LineNr"> 82 </span>parts are optional and may be in any order.  The parts may be made up
<span id="L83" class="LineNr"> 83 </span>of alphabetic fields, numeric fields, and special characters.
<span id="L84" class="LineNr"> 84 </span>
<span id="L85" class="LineNr"> 85 </span>An alphabetic field is made up of letters and must contain a whole word
<span id="L86" class="LineNr"> 86 </span>or an abbreviation <span class="textRainbow_lv0_p0">(</span>usually made up of the first three letters of the
<span id="L87" class="LineNr"> 87 </span>word<span class="textRainbow_lv0_p0">)</span>.  No distinction is made between uppercase and lowercase
<span id="L88" class="LineNr"> 88 </span>characters.  Although this description gives examples in English, each
<span id="L89" class="LineNr"> 89 </span>of the words is available in several languages.  Any of these languages
<span id="L90" class="LineNr"> 90 </span>may be used in time strings, but all words within a given string must
<span id="L91" class="LineNr"> 91 </span>be in the same language.
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>To see the languages defined on your site, type
<span id="L95" class="LineNr"> 95 </span>          display_time_info -lang
<span id="L96" class="LineNr"> 96 </span>A numeric field consists of an optionally signed integer <span class="textRainbow_lv0_p0">(</span>or fraction<span class="textRainbow_lv0_p0">)</span>
<span id="L97" class="LineNr"> 97 </span>of one or more decimal digits.  The special characters that may be used
<span id="L98" class="LineNr"> 98 </span>in either alphabetic or numeric fields are:  the slash <span class="textRainbow_lv0_p0">(</span>/<span class="textRainbow_lv0_p0">)</span>, the period
<span id="L99" class="LineNr"> 99 </span><span class="textRainbow_lv0_p0">(</span>.<span class="textRainbow_lv0_p0">)</span>, the colon <span class="textRainbow_lv0_p0">(</span>:<span class="textRainbow_lv0_p0">)</span>, the plus <span class="textRainbow_lv0_p0">(</span>+<span class="textRainbow_lv0_p0">)</span>, the minus <span class="textRainbow_lv0_p0">(</span>-<span class="textRainbow_lv0_p0">)</span>, and the comma <span class="textRainbow_lv0_p0">(</span><span class="textRainbow_lv0_o0">,</span><span class="textRainbow_lv0_p0">)</span>.
<span id="L100" class="LineNr">100 </span>Blanks are not required between alphabetic and numeric fields in the
<span id="L101" class="LineNr">101 </span>time strings; however, they are required between two numeric fields
<span id="L102" class="LineNr">102 </span>unless the second field begins with a plus <span class="textRainbow_lv0_p0">(</span>+<span class="textRainbow_lv0_p0">)</span> or minus <span class="textRainbow_lv0_p0">(</span>-<span class="textRainbow_lv0_p0">)</span> sign.  For
<span id="L103" class="LineNr">103 </span>example:
<span id="L104" class="LineNr">104 </span>        2days4hours10minutes
<span id="L105" class="LineNr">105 </span>        1245.17+7hours
<span id="L106" class="LineNr">106 </span>        10/17/79Wednesday
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>Underscores may be used in place of blanks in the time string.  For
<span id="L110" class="LineNr">110 </span>example:
<span id="L111" class="LineNr">111 </span>          09/25/79__1442.6_+5_hours
<span id="L112" class="LineNr">112 </span>
<span id="L113" class="LineNr">113 </span>Usually when a user enters a time string, the time zone is omitted.
<span id="L114" class="LineNr">114 </span>Although the zone is seldom seen, it is very important.  The time zone
<span id="L115" class="LineNr">115 </span>determines the interpretation of items given in the time string.  Also,
<span id="L116" class="LineNr">116 </span>the zone is involved in supplying defaults for missing items.  All
<span id="L117" class="LineNr">117 </span>defaults are taken from the current absolute time, adjusted by a
<span id="L118" class="LineNr">118 </span>working time zone.  If a zone is given in the string, that becomes the
<span id="L119" class="LineNr">119 </span>working zone.  Otherwise, the process default time zone is used.
<span id="L120" class="LineNr">120 </span>
<span id="L121" class="LineNr">121 </span>
<span id="L122" class="LineNr">122 </span>This means that whether you convert a string with an explicit zone,
<span id="L123" class="LineNr">123 </span>such as &quot;XXXX_ast&quot; or set the process default to &quot;ast&quot; and then convert
<span id="L124" class="LineNr">124 </span>the string &quot;XXXX&quot;, you get the same absolute time.  <span class="textRainbow_lv0_p0">(</span>Note that setting
<span id="L125" class="LineNr">125 </span>the process default will also influence output conversion<span class="textRainbow_lv0_o0">,</span> while giving
<span id="L126" class="LineNr">126 </span>an explicit zone does not.<span class="textRainbow_lv0_p0">)</span>  To display your default zone, type:
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>          print_time_defaults zone
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>Multics accepts dates from the year 0001 through 9999.  The Julian
<span id="L132" class="LineNr">132 </span>calendar is used for dates from 0001-01-01 through 1582-10-04.  The
<span id="L133" class="LineNr">133 </span>Gregorian calendar is used for dates from 1582-10-15 through
<span id="L134" class="LineNr">134 </span>9999-12-31.  <span class="textRainbow_lv0_p0">(</span>The dates from October 5<span class="textRainbow_lv0_o0">,</span> 1582 through October 14<span class="textRainbow_lv0_o0">,</span> 1582
<span id="L135" class="LineNr">135 </span>do not exist.  They were dropped when the Gregorian calendar was
<span id="L136" class="LineNr">136 </span>adopted.  The leap day is always February 29.  The lower limit on dates
<span id="L137" class="LineNr">137 </span>of January 1<span class="textRainbow_lv0_o0">,</span> 0001 AD was picked since it begins the era.  The upper
<span id="L138" class="LineNr">138 </span>limit on dates of December 31<span class="textRainbow_lv0_o0">,</span> 9999 was chosen to limit year numbers to
<span id="L139" class="LineNr">139 </span>four digits.  The time zones as now defined are used regardless of the
<span id="L140" class="LineNr">140 </span>year.  The Multics date/time system does not account for &quot;leap seconds&quot;
<span id="L141" class="LineNr">141 </span>and<span class="textRainbow_lv0_o0">,</span> therefore<span class="textRainbow_lv0_o0">,</span> the difference between any two binary clock values that
<span id="L142" class="LineNr">142 </span>are precisely an integral number of days <span class="textRainbow_lv1_p0">(</span>hours<span class="textRainbow_lv1_o0">,</span> minutes<span class="textRainbow_lv1_o0">,</span> seconds<span class="textRainbow_lv1_o0">,</span>
<span id="L143" class="LineNr">143 </span>etc.<span class="textRainbow_lv1_p0">)</span>  apart is guaranteed to be evenly divisible by the number of
<span id="L144" class="LineNr">144 </span>microseconds in a day <span class="textRainbow_lv1_p0">(</span>hour<span class="textRainbow_lv1_o0">,</span> minute<span class="textRainbow_lv1_o0">,</span> second<span class="textRainbow_lv1_o0">,</span> etc.<span class="textRainbow_lv1_p0">)</span>.
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Notes:
<span id="L148" class="LineNr">148 </span>See the Subroutines manual for a description of the six parts contained
<span id="L149" class="LineNr">149 </span>in time string.
<span id="L150" class="LineNr">150 </span>
<span id="L151" class="LineNr">151 </span>
<span id="L152" class="LineNr">152 </span>:Entry:  relative:  02/19/85 convert_date_to_binary_$relative
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>Function:
<span id="L156" class="LineNr">156 </span>This entry point is similar to the convert_date_to_binary_
<span id="L157" class="LineNr">157 </span>entry point<span class="textRainbow_lv0_o0">,</span> except that the clock reading returned is computed
<span id="L158" class="LineNr">158 </span>relative to an input clock time rather than the current clock time.
<span id="L159" class="LineNr">159 </span>Thus the clock reading returned for the string &quot;March 26&quot; is the clock
<span id="L160" class="LineNr">160 </span>reading for the first March 26 following the input clock time<span class="textRainbow_lv0_o0">,</span> rather
<span id="L161" class="LineNr">161 </span>than the clock reading for the first March 26 following the current
<span id="L162" class="LineNr">162 </span>clock time.  Given a 72-bit clock time to use<span class="textRainbow_lv0_o0">,</span> this entry point
<span id="L163" class="LineNr">163 </span>converts a character representation of a date and time to the
<span id="L164" class="LineNr">164 </span>equivalent 72-bit clock reading.
<span id="L165" class="LineNr">165 </span>
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>Syntax:
<span id="L168" class="LineNr">168 </span>declare convert_date_to_binary_$relative entry <span class="textRainbow_lv1_p0">(</span>char<span class="textRainbow_lv2_p0">(</span>*<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> fixed bin<span class="textRainbow_lv2_p0">(</span>71<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span>
<span id="L169" class="LineNr">169 </span>     fixed bin<span class="textRainbow_lv2_p0">(</span>71<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_o0">,</span> fixed bin<span class="textRainbow_lv2_p0">(</span>35<span class="textRainbow_lv2_p0">)</span><span class="textRainbow_lv1_p0">)</span>;
<span id="L170" class="LineNr">170 </span>call convert_date_to_binary_$relative <span class="textRainbow_lv1_p0">(</span>string<span class="textRainbow_lv1_o0">,</span> clock<span class="textRainbow_lv1_o0">,</span> clock_in<span class="textRainbow_lv1_o0">,</span> code<span class="textRainbow_lv1_p0">)</span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>Arguments:
<span id="L174" class="LineNr">174 </span>string
<span id="L175" class="LineNr">175 </span>   is the character representation of the clock reading desired.
<span id="L176" class="LineNr">176 </span>   <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L177" class="LineNr">177 </span>clock
<span id="L178" class="LineNr">178 </span>   is the computed clock value relative to the clock_in argument.
<span id="L179" class="LineNr">179 </span>   <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
<span id="L180" class="LineNr">180 </span>clock_in
<span id="L181" class="LineNr">181 </span>   is the clock time used to compute the clock value.  <span class="textRainbow_lv1_p0">(</span>Input<span class="textRainbow_lv1_p0">)</span>
<span id="L182" class="LineNr">182 </span>code
<span id="L183" class="LineNr">183 </span>   is a standard status code.  <span class="textRainbow_lv1_p0">(</span>Output<span class="textRainbow_lv1_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
